Show all objects where Z is not 0

In some drawing there is some objects where geometry start- end- or deltapoint for Z is not 0.
It can be block and lines. How to determine those objects? Maybe by change theirs color?

Comments

  • You can always interrogate each individual (or selection of) objects via Properties panel. And even if a selection of elements reports 'Varies' (i.e. some of the z's =zero, some them =non-zero) you can edit Properties to make all of them =zero. But you mean to see all of the z=non-zero elements highlighted together? That wd be gd.
  • Where?


  • Using Structure Browser, you can customize a structure tree configuration file (.cst) to group entities by UCS Elevation.
  • Tom Foster
    edited July 2023
    Are these elements 'All(2)' Polylines, 2DPolylines or 3DPolylines? Each produces a different display in Geometry in Properties. But I agree, Polylines and 2DPolylines can't be edited there to z=zero - only Lines (and other types?). OTOH, it seems impossible to create or modify a Polyline or 2DPolyline to make z=non-zero.
  • This Lisp code will filter and highlight all 'NonFlats' (objects whose boundingbox has a non-zero Z-coordinate) from a user selection.
    (defun c:NonFlats( / ss ssOut)
      (if (setq ss (ssget))
        (progn
          (setq ssOut (ssadd))
          (mapcar
            '(lambda(enm / box)
              (setq box (vle-getgeomextents enm))
              (if (not (= 0 (caddr (car box)) (caddr (cadr box))))
                (ssadd enm ssOut)
              )
            )
            (vle-selectionset->list ss)
          )
          (sssetfirst nil ssOut)
        )
      )
      (princ)
    )
  • Thanks!
    Seems to work just fine. It will take some time until I can check the real drawings.
  • Hm..
    I got this:

    One (1) of them:

    Object not highlighted:


    Why do I get some object highlighted here?




  • The proposed code looks at the boundingbox of objects. A block reference inserted at exactly Z=0 may have content that is not planar to the XY plane of the WCS. For further analysis I would need a DWG file.
  • Okay!

    It seems that I just can use command FLATTEN and select ALL.
    No need for NonFlats then.

    At least for a (1) set oft drawings where there is no other values than 0 for Z.

    This is "my" drawings from beginnings. I now know why this happens but I don't know why other layers are involved?

    Anyway, I'm not owner of the drawings anymore (working at another company) but try to help my former colleague.
    (The drawings is kind of secret)

    I'm awaiting for a set of drawings where there actually is wrong value for Z.